//bug: ele está calculando ingredientes de múltiplo rendimento incorretamente. Ao pedir 64 loquat juices com a opção -DCISBM, ele calcula 22x3 for 64 honeys, como se este fosse ser fabricado e não comprado.


/* Created 2016-sep-07 12h06 */

/* This code is public domain where applicable, all FFXIV trademarks belong to SquareEnix */

/* Compiled on Windows with:

 windres resource.rc resource.o
 gcc -O3 -s -g0 -Wall main.c resource.o -o FFXIVShoppingList.exe -mwindows -lcurl -I"%CURLINCLUDEPATH%" -L"%CURLLIBRARYPATH%"

 */

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
#undef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#define dirsep "\\"
#else
#define dirsep "/"
#endif

#include "curl.h"

#define ERROR_WEB 1
#define ERROR_NORECIPE 2
#define ERROR_TEMPLATE 3
#define ERROR_CACHEDIRECTORY 4
#define ERROR_OUTOFBOUNDS 5

#define MAXMATS 1000

#define VERSION_STRING "Alpha 6"

struct _MAT
{
	char n[100]; /* dumb assumption */
	int q;
	int a;
	char c;
	unsigned short s;
	char lv;
	char y;
	int g;
	char mg;
};
typedef struct _MAT MAT;


int compar(const void* pa,const void* pb);
int getrecipe(char* r, int* nmats, MAT* mats, int rq, int lv, char* error);
void changedtemplateerror(const char* lookingfor, char *error);
void printParameterList(void);
int getYield(char *html, char* error);
int getRecipeHTML(char* r, char** html, int*wasDownloaded, int *oid, char *error);
int getPage(char *page, FILE *file);
void multimsg(const char *msg);
int readJSON(char *json, const char *start, const char *end, char *out);
int newMaterial(int matid, char *n, int lv, int class, int *nmats, MAT *mats, char *error);

#ifdef WIN32
BOOL CALLBACK DialogProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam);
#endif


int seed=0;
int verbose=0;
int omitCrystals=0;
int dontCraftItemsSoldByMerchants=0;
int craftBeastTribeItems=0;
int craftMaterialGear=0;
int refreshCache=0;
int ui=0;

MAT* gmats;
char *refreshed;
CURL *curl;
char *garlanddb;
int garlanddblen;
char cd[100];
#if WIN32
HWND mainDlg=NULL;
#endif

void printParameterList(void)
{
	printf("Parameter list:\n");
	printf("-v or -verbose\n");
	printf("-oc or -omit-crystals\n");
	printf("-dcisbm or -dont-craft-items-sold-by-merchants\n");
	printf("-cbti or -craft-beast-tribe-items\n");
	printf("-cmg or -craft-material-gear\n");
	printf("-rc or -refresh-cache\n");
}

void changedtemplateerror(const char* lookingfor, char *error)
{
	printf("GarlandDB template changed. Message: [%s].\n", lookingfor);
	if (error) sprintf(error, "GarlandDB template changed. Message: [%s].\n", lookingfor);
	#ifdef WIN32
		MessageBox(NULL, "GarlandDB template changed. Message:", lookingfor, 0);
	#endif
}

int getRecipeHTML(char* r, char** html, int*wasDownloaded, int *oid, char *error)
{
	FILE *file=NULL;
	int itemId;
	char *cachefile=NULL;
	char *url=NULL;
	size_t len;
	size_t read;
	char *pos;
	char *temp=NULL;
	int ret=0;


	itemId=0;


	cachefile=malloc(1000);
	sprintf(cachefile, "cache" dirsep "%s", r);
	file=fopen(cachefile, "rb");
	*wasDownloaded=0;

	if (verbose) printf("Retrieving recipe for %s... ", r);


	temp=malloc(50000);
	url=malloc(1000);

	if (!file || refreshCache)
	{

		if (!refreshCache || (refreshCache && (!itemId || (itemId && !refreshed[itemId]))))
		{
			if (file) fclose(file);
			file = fopen(cachefile, "wb+");
			if (!file)
			{
				printf("Error opening cache file for [%s]. Ensure the cache folder exists alongside the program.\n", r);
				if (error) sprintf(error, "Error opening cache file for [%s]. Ensure the cache folder exists alongside the program.\n", r);
				ret=ERROR_CACHEDIRECTORY;
				goto cleanup;
			}

			if (!itemId)
			{
				if (verbose) printf("Retrieving index for %s... ", r);

				sprintf(url, "http://www.garlandtools.org/api/search.php?text=%s&lang=en", r);
				if (!getPage(url, file))
				{
					printf("Web error on [%s]\n",  r);
					if (error) sprintf(error, "Web error on [%s]\n", r);
					ret=ERROR_WEB;
					goto cleanup;
				}
				if (verbose) printf(" from web\n");

				fseek(file, 0, SEEK_END);
				len=ftell(file);
				fseek(file, 0, SEEK_SET);
				read=fread(temp, len, 1, file);
				fseek(file, 0, SEEK_SET);

				pos=strstr(temp, "\"n\":\"");
				if (!pos)
				{
					ret=ERROR_TEMPLATE;
					goto cleanup;
				}
				if (strncmp(pos+5, "Aetherial", 9)) pos=temp;

				if (!readJSON(pos, "\"id\":\"", "\"", url))
				{
					ret=ERROR_TEMPLATE;
					goto cleanup;
				}


				itemId=strtol(url, NULL, 10);
			}

			sprintf(url, "http://www.garlandtools.org/db/doc/item/en/2/%d.json", itemId);
			if (!getPage(url, file))
			{
				printf("Web error on [%s]\n",  r);
				if (error) sprintf(error, "Web error on [%s]\n", r);
				ret=ERROR_WEB;
				goto cleanup;
			}
			if (verbose) printf(" from web\n");
			refreshed[itemId]=1;
			*wasDownloaded=1;
		}
		else if (verbose) printf(" from refreshed disk cache\n");
	}
	else if (verbose) printf(" from disk cache\n");
	fseek(file, 0, SEEK_END);
	len=ftell(file);
	fseek(file, 0, SEEK_SET);
	*html=calloc(1, len+1);
	read=fread(*html, len, 1, file);


	readJSON(*html, "\"id\":", ",", url);
	itemId=strtol(url, NULL, 10);

	if (!itemId)
	{
		ret=ERROR_TEMPLATE;
		goto cleanup;

	}
	if (itemId>65536)
	{
		ret=ERROR_OUTOFBOUNDS;
		goto cleanup;
	}

	if (oid) *oid=itemId;


	if (read!=1)
	{
		printf("Error reading cache file for [%s].\n", r);
		if (error) sprintf(error, "Error reading cache file for [%s].\n", r);
		ret=ERROR_CACHEDIRECTORY;
		goto cleanup;
	}


	pos=strstr(*html, ",\"related\"");
	if (pos) *pos='\0';


cleanup:

	if (file) fclose(file);
	if (cachefile) free(cachefile);
	if (url) free(url);
	if (temp) free(temp);
	return ret;
}

int getYield(char *html, char* error)
{
	int yield=1;

	char *pos2, *pos3, *posing;

	posing=strstr(html, "\"ingredients\"");
	if (posing) *posing='\0';
	pos2=strstr(html, ",\"yield\":");
	if (posing) *posing='"';

	if (pos2)
	{
		pos3=strstr(pos2, ",");
		if (!pos3) { changedtemplateerror("1", error); return 0; }
		*pos3='\0';
		yield=strtol(pos2+9, NULL, 10);
		*pos3=',';
	}
	return yield;
}

int getPage(char *page, FILE *file)
{
	int ret=0;
    char *url=malloc(2000);
    char *pos, *pos2, *pos3, *pos4;
	CURLcode curlret;

	pos=page;
	pos3=url;
	pos4=0;
	while ((pos2=strchr(pos, ' ')))
	{
		pos4=pos2;
		strncpy(pos3, pos, pos2-pos);
		pos3+=pos2-pos;
		strcpy(pos3, "%20");
		pos3+=3;
		pos=pos2+1;
	}
	pos2=pos4?pos4:(page-1);
	strcpy(pos3, pos2+1);

	curl_easy_setopt(curl, CURLOPT_URL, url);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, file);
	curlret=curl_easy_perform(curl);

    if (curlret!= CURLE_OK)
    {
        goto error;
    }

    ret=1;

 error:
 	 free(url);
 	 return ret;
}

int getrecipe(char* r, int* nmats, MAT* mats, int rq, int lv, char *error)
{
	int ret;
	int soldByMerchant, beastTribe, gear, merchantQty, matid, origmat;
	int class;
	char *pos, *pos2, *pos3, *ingpos, *partialspos, *nodepos;
	char* buffer=NULL;
	int q, x, i;
	char *n;
	int wasDownloaded=0;
	char temp[1000];

	ret=0;

	printf(".");
	fflush(stdout);
	#ifdef WIN32
	RedrawWindow(mainDlg, NULL, NULL, RDW_ALLCHILDREN);
	#endif

	matid=-1;
	if ((x=getRecipeHTML(r, &buffer, &wasDownloaded, &matid, error))) return x;

	if (matid==-1)
	{
		sprintf(buffer, "Couldn't find a GarlandDB page for [%s]", r);
		printf("%s\n", buffer);
		if (error) strcpy(error, buffer);
		free(buffer);
		return ERROR_NORECIPE;
	}

	n=malloc(1000);

	partialspos=strstr(buffer, "partials");
	if (partialspos) *partialspos='\0';


	if (readJSON(buffer, "\"job\":", ",", temp))
	{
		class=strtol(temp, NULL, 10)+1;
	}
	else class=0;


	x=-1;
	for (i=0; i < *nmats; i++) if (!strcmp(r, mats[i].n)) {x=i; break; }
	if (x!=-1) mats[x].c=class; else if (lv) { newMaterial(matid, r, lv, class, nmats, mats, error); x=*nmats; }
	origmat=x;
	gear=readJSON(buffer, "\"equip\":", ",", temp) && (*temp=='1');
	if (x!=-1)
	{
		*temp=0;
		pos=strstr(buffer, "\"ingredients\"");
		if (pos) *pos='\0';
		nodepos=0;
		{ readJSON(buffer, "\"nodes\":[", ",", temp); if (*temp) nodepos=partialspos+1; }
		if (!*temp) { readJSON(buffer, "\"nodes\":[", "]", temp);  if (*temp) nodepos=partialspos+1; }
		if (!*temp && !class) { pos2=strstr(partialspos+1, "{\"type\":\"mob\",\"id\":\""); if (pos2) readJSON(pos2, "\"z\":", "}", temp); }
		if (!*temp && !class) { pos2=strstr(partialspos+1, "{\"type\":\"fishing\",\"id\":\""); if (pos2) readJSON(pos2, "\"z\":", "}", temp); }
		if (nodepos && !class) { pos2=strstr(nodepos, "{\"type\":\"node\",\"id\":\""); if (pos2) readJSON(pos2, "\"z\":", "}", temp); }
		if (!*temp) { readJSON(buffer, "\"vendors\":[", ",", temp); }
		if (!*temp) { readJSON(buffer, "\"vendors\":[", "]", temp); }
		if (*temp) mats[x].g=strtol(temp, NULL, 10);
		if (pos) *pos='"';
		mats[x].mg=gear;
	}


	if ((ingpos=strstr(buffer, "\"ingredients\":")))
	{
		*ingpos='\0';
		soldByMerchant=(pos=strstr(buffer, "\"vendors\":"))!=NULL;
		*ingpos='\"';
		beastTribe=0;
		if (soldByMerchant)
		{
			pos2=strchr(pos, ']');
			if (!pos2) { changedtemplateerror("2", error); ret=ERROR_TEMPLATE; goto cleanup; }
			*pos2='\0';

			/* don't wanna go to the trouble of bringing in and treating the database beyond simple text search */
			beastTribe=
				strstr(pos, "1005554") || /*Amalj'aa Vendor*/
				strstr(pos, "1005569") || /*Sylphic Vendor*/
				strstr(pos, "1008909") || /*Kobold Vendor*/
				strstr(pos, "1008907") || /*Sahagin Vendor*/
				strstr(pos, "1009205") || /*Ixali Vendor*/
				strstr(pos, "1016093") || /*Luna Vanu*/
				strstr(pos, "1016804") || /*Vath Stickpeddler*/
				strstr(pos, "1017337") ;  /*Mogmul Mogbelly*/

			pos3=pos;
			merchantQty=1;
			while (*pos3) if (*pos3++==',') merchantQty++;

			*pos2=']';

			if ((origmat>0) && dontCraftItemsSoldByMerchants && beastTribe && craftBeastTribeItems && (merchantQty==1)) mats[origmat].g=0;

		}

		if (!soldByMerchant || !lv || (lv && soldByMerchant && (!dontCraftItemsSoldByMerchants || (dontCraftItemsSoldByMerchants && ((beastTribe && craftBeastTribeItems && (merchantQty==1)) || (gear && craftMaterialGear))) )))
		{
			int add, pq, interror;
			char *ingend;

			ingend=strchr(ingpos, ']');
			if (!ingend) { changedtemplateerror("3", error); ret=ERROR_TEMPLATE; goto cleanup; }

			while ((ingpos=strstr(ingpos, "{")) && (ingpos<ingend))
			{
				ingpos++;

				if (readJSON(ingpos, "\"id\":", ",", temp)) matid=strtol(temp, NULL, 10);
				else { changedtemplateerror("4", error); ret=ERROR_TEMPLATE; goto cleanup; }


				if (readJSON(ingpos, "\"amount\":", ",", temp) || readJSON(ingpos, "\"amount\":", "}", temp))
				{
					q=strtol(temp, NULL, 10);
				}
				else { changedtemplateerror("5", error); goto cleanup; }

				*n='\0';
				sprintf(temp, "\",\"id\":%d,", matid);
				pos=strstr(ingpos, temp);
				while (pos && (pos>ingpos) && *pos!='{')
				{
					if (!strncmp(pos, "\"name\"", 6))
					{
						strcpy(temp, "\"name\":\"");
						break;
					}
					else pos--;
				}

				if (!pos || (*pos=='{'))
				{
					sprintf(temp,  "\"id\":%d,\"en\":{\"name\":\"", matid);
					pos=strstr(garlanddb, temp);
				}
				if (pos)
				{
					pos+=strlen(temp);
					pos2=strchr(pos, '"');
					if (pos2)
					{
						strncpy(n, pos, pos2-pos);
						n[pos2-pos]='\0';
					}
				}
				if (!pos)
				{
					changedtemplateerror("6", error); goto cleanup;
				}

				x=-1;
				for (i=0; i < *nmats; i++)
				if (!strcmp(mats[i].n, n))
				{
					x=i;
					break;
				}
				if (x==-1)
				{
					newMaterial(matid, n, lv, 0, nmats, mats, error);
					x=(*nmats)-1;
				}

				add=q*rq;

				mats[x].a+=add;
				pq=mats[x].q;
				mats[x].q=mats[x].a / mats[x].y;
				if ((mats[x].q*mats[x].y)<mats[x].a)mats[x].q++;

				if (pq!=mats[x].q)
				{
					if (verbose) printf("Adding %d to %s\n", add, mats[x].n);

					if (origmat>-1) cd[(uint32_t) mats[origmat].c]++;
					interror=getrecipe(mats[x].n, nmats, mats, mats[x].q-pq, lv+1, error);
					if (interror) { ret=interror; goto cleanup; }
				}
			}
		}
	}
	else if (verbose) printf("[%s] has no recipe.\n", r);

cleanup:

	free(buffer);
	free(n);

	return ret;
}


int compar(const void* pa,const void* pb)
{
	const MAT *a=(const MAT*)pa, *b=(const MAT*)pb;
	int c = a->c-b->c;
	int s = a->s-b->s;
	int l = b->lv-a->lv;
	int d = 0;/*cd[(uint32_t) b->c]-cd[(uint32_t) a->c];*/
	int g = a->g-b->g;
	int _g= !a->g-!b->g;
	int mg = a->mg-b->mg;

	return (mg?mg:(d?d:(_g?_g:(g?g:(l?l:(c?c:(s?s:strcmp(a->n, b->n))))))));
}

void multimsg(const char *msg)
{
	if (!ui) printf("%s\n", msg);
	else
	{
		#ifdef WIN32
			MessageBox(mainDlg, msg, "Message", MB_ICONINFORMATION);
		#endif
	}
}

/* not thread-safe */
int readJSON(char *json, const char *start, const char *end, char *out)
{
	char *pos, *pos2;

	pos=strstr(json, start);
	if (!pos) return 0;

	pos2=strstr((pos+=strlen(start)), end);
	if (!pos2) return 0;

	*pos2='\0';
	strcpy(out, pos);
	*pos2=*end;

	return 1;
}

int newMaterial(int matid, char *n, int lv, int class, int *nmats, MAT *mats, char *error)
{
	int tempint, temperr, yield, x;
	char *tempHTML;

	x=*nmats;
	*nmats=x+1;
	strcpy(mats[x].n, n);
	mats[x].s=+seed++;
	mats[x].lv=lv;
	if ((temperr=getRecipeHTML(n, &tempHTML, &tempint, NULL, error))) return temperr;
	yield=getYield(tempHTML, error);
	if (!yield) { free(tempHTML); return ERROR_TEMPLATE; }
	mats[x].y=yield;
	mats[x].c=class;
	if (verbose) printf("New material %d [%s]\n", matid, mats[x].n);
	return 0;
}


#ifdef WIN32

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			CheckDlgButton(hwndDlg, ID_OC, TRUE);
			CheckDlgButton(hwndDlg, ID_DCISBM, TRUE);
			CheckDlgButton(hwndDlg, ID_CBTI, TRUE);
			CheckDlgButton(hwndDlg, ID_CMG, TRUE);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case ID_GENERATE:
				{
					UINT recipeLen, recipeMaxLen=1000000;
					char *recipes=malloc(recipeMaxLen+1);
					char *cRecipe=malloc(recipeMaxLen+1);
					char *shopping=malloc(recipeMaxLen+1);
					char *error=malloc(recipeMaxLen+1);

					SendDlgItemMessage(hwndDlg, IDC_PROGRESS1, PBM_SETPOS, 0, 0);

					omitCrystals=IsDlgButtonChecked(hwndDlg, ID_OC);
					dontCraftItemsSoldByMerchants=IsDlgButtonChecked(hwndDlg, ID_DCISBM);
					craftBeastTribeItems=IsDlgButtonChecked(hwndDlg, ID_CBTI);
					craftMaterialGear=IsDlgButtonChecked(hwndDlg, ID_CMG);
					refreshCache=IsDlgButtonChecked(hwndDlg, ID_RC);
					memset(refreshed, 0, 65536);
					memset(cd, 0, sizeof(cd));


					recipeLen=GetDlgItemText(hwndDlg, ID_RECIPE, recipes, recipeMaxLen);
					if (recipeLen==recipeMaxLen)
					{
						MessageBox(hwndDlg, "Recipe list too big", "Recipe list too big", MB_ICONWARNING);
					}
					else if (!recipeLen)
					{
						MessageBox(hwndDlg, "Recipe list empty", "Recipe list empty", MB_ICONWARNING);
					}
					else
					{
						char *token, *pos, scount[100];
						int qtyLen, qty, *nmats, failed=0, i, count, n;

						nmats=calloc(1, sizeof(int));
						count=1;
						token = strtok(recipes, "\r\n");
						while (token!=NULL) { token=strtok(NULL, "\r\n"); count++; }
						SendDlgItemMessage(hwndDlg, IDC_PROGRESS1, PBM_SETPOS, 100 / count - 1, 0);
						sprintf(scount, "%d%%", 100 / count - 1);
						SetDlgItemText(hwndDlg, ID_GENERATE, scount);

						seed=0;
						GetDlgItemText(hwndDlg, ID_RECIPE, recipes, recipeMaxLen);
						memset(gmats, 0, MAXMATS*sizeof(MAT));
						token = strtok(recipes, "\r\n");
						n=1;
						while (token!=NULL)
						{
							recipeLen=strlen(token);
							if (recipeLen)
							{
								pos=&token[recipeLen-1];
								qty=1; qtyLen=0; while (((*pos)>='0') && ((*pos)<='9')) { qtyLen++; pos--; }
								if (qtyLen)
								{
									qty=strtol(&token[recipeLen-1]-qtyLen+1, NULL, 10);
								}
								strcpy(cRecipe, token);
								if (qtyLen) cRecipe[recipeLen-qtyLen]='\0';
								pos=&cRecipe[strlen(cRecipe)-1];
								while (*pos==' ') *pos--='\0';

								if (getrecipe(cRecipe, nmats, gmats, qty, 0, error))
								{
									failed=1;
									break;
								}

								token = strtok(NULL, "\r\n");

								SendDlgItemMessage(hwndDlg, IDC_PROGRESS1, PBM_SETPOS, (100 * ++n) / count - 1, 0);
								sprintf(scount, "%d%%", (100 * n) / count - 1);
								SetDlgItemText(hwndDlg, ID_GENERATE, scount);
							}
						}

						if (!failed)
						{

							sprintf(shopping, "Shopping list:\r\n");
							if (*nmats) qsort(gmats, *nmats, sizeof(MAT), compar);
							for (i=0; i < *nmats; i++)
							{
								if (omitCrystals && ((strstr(gmats[i].n, " Crystal\0") && !strstr(gmats[i].n, "Mhigan"))  || strstr(gmats[i].n, " Shard\0") || strstr(gmats[i].n, " Cluster\0"))) continue;
								sprintf(&shopping[strlen(shopping)], "%5d\t%s", gmats[i].q, gmats[i].n);
								if (gmats[i].y>1) sprintf(&shopping[strlen(shopping)], " (%d x %d for %d)", gmats[i].q, gmats[i].y, gmats[i].a);
								sprintf(&shopping[strlen(shopping)], "\r\n");
							}

							SetDlgItemText(hwndDlg, ID_SHOPPING, shopping);
							CheckDlgButton(hwndDlg, ID_RC, BST_UNCHECKED);
						}
						else
						{
							sprintf(shopping, "Error while getting recipe [%s]: %s\r\n", cRecipe, error);
							SetDlgItemText(hwndDlg, ID_SHOPPING, shopping);
						}

						free(nmats);
						SetDlgItemText(hwndDlg, ID_GENERATE, "Generate");

					}

					free(recipes);
					free(cRecipe);
					free(error);
					free(shopping);

					return TRUE;
				}
				case IDCANCEL:
					PostQuitMessage(0);
					return TRUE;
				default:
					break;
			}
			break;
		case WM_QUIT:
			DestroyWindow(hwndDlg);
			return TRUE;
		default:
			break;
	}

	UNREFERENCED_PARAMETER(lParam);

    return FALSE;
}

#endif


int main(int argc, char* argv[])
{
	char *p;
	int nmats, i, j;
	FILE *garlanddbfile;



	#ifdef WIN32
    ui=!AttachConsole((DWORD)-1);
	#endif

	curl = curl_easy_init();
	curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 1L);
	curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 1L);
	curl_easy_setopt(curl, CURLOPT_AUTOREFERER, 1L);
	curl_easy_setopt(curl, CURLOPT_ACCEPT_ENCODING, "");
	curl_easy_setopt(curl, CURLOPT_TRANSFER_ENCODING, 1L);
	curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
	curl_easy_setopt(curl, CURLOPT_TIMEOUT, 30L);
	curl_easy_setopt(curl, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.107 Safari/537.36");
	
	nmats=0;
	gmats=calloc(MAXMATS, sizeof(MAT));
	refreshed=calloc(1, 65536);
	memset(cd, 0, sizeof(cd));


	garlanddbfile=fopen("cache" dirsep "garlanddbcore", "rb");
	if (!garlanddbfile)
	{
		int ret;
		char page[200];

		multimsg("Loading GarlandDB core for the first time...");
		garlanddbfile=fopen("cache" dirsep "garlanddbcore", "wb");
		strcpy(page,"http://www.garlandtools.org/db/doc/core/en/2/data.json");
		ret=getPage(page, garlanddbfile);
		if (!ret)
		{
			multimsg("Cannot open http://www.garlandtools.org/db/doc/core/en/2/data.json");
			goto cleanup;
		}
		garlanddbfile=fopen("cache" dirsep "garlanddbcore", "rb");
	}
	fflush(garlanddbfile);
	fseek(garlanddbfile, 0, SEEK_END);
	garlanddblen=ftell(garlanddbfile);
	fseek(garlanddbfile, 0, SEEK_SET);
	garlanddb=malloc(garlanddblen+1);
	fread(garlanddb, garlanddblen, 1, garlanddbfile);
	fclose(garlanddbfile);
	memmove(garlanddb, strstr(garlanddb, "\"ingredients\":"), (garlanddb+strlen(garlanddb))-strstr(garlanddb, "\"ingredients\":")+1);


	if (!ui)
	{
		printParameterList();

		if (argc > 1)
		{
			int failed=0;

			printf("FFXIV Shopping list generator by BRELS %s\n", VERSION_STRING);
			printf("Will generate shopping list with %d item%s.\n", argc-1, (argc>1)?"s":"");


			for (i=1; i < argc; i++)
			{
				p=argv[i];
				if (!strcasecmp(p, "-v") || !strcasecmp(p, "-verbose")) verbose=1;
				if (!strcasecmp(p, "-oc") || !strcasecmp(p, "-omit-crystals")) omitCrystals=1;
				if (!strcasecmp(p, "-dcisbm") || !strcasecmp(p, "-dont-craft-items-sold-by-merchants")) dontCraftItemsSoldByMerchants=1;
				if (!strcasecmp(p, "-cbti") || !strcasecmp(p, "-craft-beast-tribe-items")) craftBeastTribeItems=1;
				if (!strcasecmp(p, "-cmg") || !strcasecmp(p, "-craft-material-gear")) craftMaterialGear=1;
				if (!strcasecmp(p, "-rc") || !strcasecmp(p, "-refresh-cache")) refreshCache=1;
			}

			for (i=1; i < argc; i++)
			{
				int cn, nn, ret;

				p=argv[i];
				cn=strspn(p, "0123456789")!=0;
				nn=(i < (argc-1)) && strspn(argv[i+1], "0123456789");
				if ((*p!='-') && !cn)
					if ((ret=getrecipe(p, &nmats, gmats, nn?atoi(argv[i+1]):1, 0, NULL)))
					{
						printf("Error %d", ret);
						failed=1;
						break;
					}
			}

			printf("\n");

			if (!failed)
			{
				qsort(gmats, nmats, sizeof(MAT), compar);
				for (i=0; i < nmats; i++)
				{
					if (omitCrystals && ((strstr(gmats[i].n, " Crystal\0") && !strstr(gmats[i].n, "Mhigan")) || strstr(gmats[i].n, "Shard\0") || strstr(gmats[i].n, " Cluster\0"))) continue;
					printf("%4d %s", gmats[i].q, gmats[i].n);
					if (gmats[i].y>1) printf(" (%d x %d for %d)", gmats[i].q, gmats[i].y, gmats[i].a);
					if (verbose)
					{
						j=40-strlen(gmats[i].n);
						if (j<0) j=1;

						printf("%*sq:%2d a:%2d c:%2d s:%3d lv:%d y:%d g:%8d mg:%d", j, "", gmats[i].q, gmats[i].a, gmats[i].c, gmats[i].s, gmats[i].lv, gmats[i].y, gmats[i].g, gmats[i].mg);
					}

					printf("\n");
				}
			}

		}
		else
		{
			printf("No item name was input.\n");
		}

	}
	#ifdef WIN32
	else
	{
		BOOL bRet;
		MSG msg;

		mainDlg = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), GetDesktopWindow(), (DLGPROC) DialogProc);
		SetWindowText(mainDlg, "FFXIV Shopping list generator by BRELS " VERSION_STRING);
        ShowWindow(mainDlg, SW_SHOW);

        if (mainDlg)
        {
			while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0)
			{
				if (bRet == -1)
				{
					MessageBox(NULL, "Windows error", "Windows error", MB_ICONERROR);
					break;
				}
				else if (!IsDialogMessage(mainDlg, &msg))
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
        }

	}
	#endif

cleanup:

	if (!ui)
	{
		#ifdef WIN32
		FreeConsole();
		#endif
	}

	curl_easy_cleanup(curl);
	free(gmats);
	free(refreshed);
	free(garlanddb);

	return 0;
		
}
